# 31 Dec 2012 - SAM
#             - initial revision
# This is a script that will compile the two revision of the Partial Reconfiguration example design.
#
# Load the flow package 
load_package flow
# Remove existing database if there
qexec "rm -rf db"
qexec "rm -rf incremental_db"
# Open Project top, revision top (the mult revision) and remove persona assignment, write assignments
project_open -revision top top
set_global_assignment -name INPUT_PERSONA persona/top.root_partition.persona -section_id Top -remove
export_assignments
# Compile this revision
execute_flow -compile
# Close the project
project_close

# Open Project top, revision switch_ISSP (the add revision), add persona assignment for Top parition, write assignments
project_open -revision switch_ISSP top
set_global_assignment -name INPUT_PERSONA persona/top.root_partition.persona -section_id Top
export_assignments
# Compile this revision
execute_flow -compile
# Close the project
project_close

# This really isn't required but added for completeness. Add back the assignment for the Top revision to use current Top partition persona
# we will only be updating the MIF so everything will work without this
project_open -revision top top
set_global_assignment -name INPUT_PERSONA persona/top.root_partition.persona -section_id Top
export_assignments
project_close

# The following commands generate the programming files for the partition blocks, update the MIF and regenerate the SOF
# When this is completed, program the FPGA with the resulting top.sof
# REQUIRES: opt.txt which set some of the options used by the commands
qexec "quartus_cpf -p ./output_files/top.x64y17.msf ./output_files/top.sof ./output_files/top.x64y17.pmsf"
qexec "quartus_cpf -p ./output_files/switch_ISSP.x64y17.msf ./output_files/switch_ISSP.sof ./output_files/switch_ISSP.x64y17.pmsf"
# For internal mem, make sure ini file has pgmio_write_pr_text_file=mif
qexec "quartus_cpf -o opt.txt -c ./output_files/top.x64y17.pmsf ./output_files/PR1_persona.rbf"
qexec "quartus_cpf -o opt.txt -c ./output_files/switch_ISSP.x64y17.pmsf ./output_files/PR2_persona.rbf"
qexec "cp ./output_files/PR1_persona.mif mult_rom_pr.mif"
qexec "cp ./output_files/PR2_persona.mif add_rom_pr.mif"
# Update Memory Initialization Files - for revision top
qexec "quartus_cdb top --rev=top --update_mif"
# Run the Assembler - for revision top
qexec "quartus_asm top -c top"
