// ================================================================================
// (c) 2012 Altera Corporation. All rights reserved.
// Altera products are protected under numerous U.S. and foreign patents, maskwork
// rights, copyrights and other intellectual property laws.
// 
// This reference design file, and your use thereof, is subject to and governed
// by the terms and conditions of the applicable Altera Reference Design License
// Agreement (either as signed by you, agreed by you upon download or as a
// "click-through" agreement upon installation andor found at www.altera.com).
// By using this reference design file, you indicate your acceptance of such terms
// and conditions between you and Altera Corporation.  In the event that you do
// not agree with such terms and conditions, you may not use the reference design
// file and please promptly destroy any copies you have made.
// 
// This reference design file is being provided on an "as-is" basis and as an
// accommodation and therefore all warranties, representations or guarantees of
// any kind (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.  By making this reference design file
// available, Altera expressly does not recommend, suggest or require that this
// reference design file be used in combination with any other product not
// provided by Altera.
//
// configurable block "freeze" wrapper to stop signals during partial reconfiguration
module pr_wrapper(
		  input 	freeze,
		  input [9:0] 	data_a_in,
		  input [9:0] 	data_b_in,
		  input 	clk,
		  output [31:0] data_out
		  );
    
    reg [31:0] 			data_out_reg;
    reg [9:0] 			data_a_reg, data_b_reg;

    wire [19:0] 		data_out_wire;
    
    assign data_out = data_out_reg;
    
    always @(posedge clk)
    begin
	data_a_reg   <= freeze ? {10{1'b1}} : data_a_in;
	data_b_reg   <= freeze ? {10{1'b1}} : data_b_in;
	data_out_reg <= freeze ? {32{1'b1}} : { 12'h000,data_out_wire };
    end

    configurable_block pr_inst(
			       .clk       ( clk		  ),
			       .input_a   ( data_a_reg    ),
			       .input_b   ( data_b_reg    ),
			       .o_value   ( data_out_wire )
			       );
endmodule // top
