// ================================================================================
// (c) 2012 Altera Corporation. All rights reserved.
// Altera products are protected under numerous U.S. and foreign patents, maskwork
// rights, copyrights and other intellectual property laws.
// 
// This reference design file, and your use thereof, is subject to and governed
// by the terms and conditions of the applicable Altera Reference Design License
// Agreement (either as signed by you, agreed by you upon download or as a
// "click-through" agreement upon installation andor found at www.altera.com).
// By using this reference design file, you indicate your acceptance of such terms
// and conditions between you and Altera Corporation.  In the event that you do
// not agree with such terms and conditions, you may not use the reference design
// file and please promptly destroy any copies you have made.
// 
// This reference design file is being provided on an "as-is" basis and as an
// accommodation and therefore all warranties, representations or guarantees of
// any kind (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.  By making this reference design file
// available, Altera expressly does not recommend, suggest or require that this
// reference design file be used in combination with any other product not
// provided by Altera.
//
// Revision History
// 31 Dec 2012 - S. Masepohl
//             - initial revision
// The pins on the Stratix V Devkit set to logic '0' when pressed, otherwise sit at '1'
// switch power-ups to 1'b1
module button_set(
		  // Inputs
		  input      clk,
		  input      pb_n_pin,
		  output reg pb = 'b0,
		  output reg switch = 'b1
		  );
   reg [24:0] 			    userpb1_count = 'b0;
   reg [2:0] 			    userpb1_r = 'b0;
   reg				    userpb1_state = 'b0;
   
   always @(posedge clk) begin
      userpb1_r     <= {userpb1_r[1:0], pb_n_pin};
      userpb1_state <= userpb1_state;
      userpb1_count <= 'b0;
      switch       <= 'b0;
   
      case ( userpb1_state )

	1'b0: begin
	   userpb1_count <= 'b0;
	   if ( !userpb1_r[2] ) begin
	      userpb1_state <= 1'b1;
	      switch        <= ~switch;
	      pb            <= 1'b1;
	   end
	   else begin
	      switch        <= switch; 
	      userpb1_state <= 1'b0;
	      pb            <= 1'b0;
	   end
	end
	
	1'b1: begin
	   pb      <= 1'b0;
	   switch <= switch;
	   if ( userpb1_count[24] ) begin
	      userpb1_state <= 1'b0;
	      userpb1_count <= 'b0;
	   end
	   else begin
	      userpb1_state <= 1'b1;
	      userpb1_count <= userpb1_count + 1'b1;
	   end
	end
      endcase // case ( userpb1_state )
   end // always @ (posedge clk)
         
endmodule // button_set







