// ================================================================================
// (c) 2012 Altera Corporation. All rights reserved.
// Altera products are protected under numerous U.S. and foreign patents, maskwork
// rights, copyrights and other intellectual property laws.
// 
// This reference design file, and your use thereof, is subject to and governed
// by the terms and conditions of the applicable Altera Reference Design License
// Agreement (either as signed by you, agreed by you upon download or as a
// "click-through" agreement upon installation andor found at www.altera.com).
// By using this reference design file, you indicate your acceptance of such terms
// and conditions between you and Altera Corporation.  In the event that you do
// not agree with such terms and conditions, you may not use the reference design
// file and please promptly destroy any copies you have made.
// 
// This reference design file is being provided on an "as-is" basis and as an
// accommodation and therefore all warranties, representations or guarantees of
// any kind (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.  By making this reference design file
// available, Altera expressly does not recommend, suggest or require that this
// reference design file be used in combination with any other product not
// provided by Altera.
//
// Revision History
// 31 Dec 2012 - SAM
//             - added channel ability and export of really_done to top

module checkout_top (
		     // Inputs
		     input  areset,
		     input  clk, 
		     input  channel,
		     input  allow_pr_start,
		     // Outputs
		     output testing_done, 
		     output pr_freeze, 
		     output error_flag_pr, 
		     output really_done
		     );
   
   wire 			    pr_start,
				    ready_for_pr,
				    pr_error,
				    crc_error;   
   
   // Main Control block and PR interface
   pr_engine m_pr_engine 
     (
      .sreset          ( areset         ),
      .clk             ( clk            ),
      .channel         ( channel        ),
      .pr_start        ( pr_start       ),
      .crc_error       ( crc_error      ),
      .pr_error        ( pr_error       ),
      .pr_really_done  ( really_done    ),
      .ready_for_pr    ( ready_for_pr   ),
      .allow_pr_start  ( allow_pr_start )
      );

   
   // Main testing flow
   main_flow m_main_flow
     (
      .sreset         ( areset         ),	
      .pr_really_done ( really_done    ),
      .ready_for_pr   ( ready_for_pr   ),
      .pr_freeze      ( pr_freeze      ),
      .pr_start       ( pr_start       ),
      .clk            ( clk            ),
      .crc_error      ( crc_error      ),
      .pr_error       ( pr_error       ),
      .testing_done   ( testing_done   ),
      .error_flag_pr  ( error_flag_pr  ),
      .allow_pr_start ( allow_pr_start )
      );
   
endmodule // checkout_top


